<?php
/*
Plugin Name: CMSify
Plugin URI: http://www.devbits.ca/
Description: CMSify your WordPress!  Additional options for extended features or hiding unneeded widgets, column and more!
Author: M. Fitzpatrick
Version: 0.7
Author URI: http://www.devbits.ca/

 Copyright 2011 Devbits  (email : m@devbits.ca)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

class CMSIFY{
	var $default_settings = Array();
	function CMSIFY(){	
		if ( is_admin() ){ // admin actions
		  //PLUGIN
		  add_action( 'admin_menu',  array($this, 'Add2Menu') );
		  if( $_GET['page'] == 'cmsify'):
			  add_action('admin_print_scripts', array($this, 'AdminScripts') );
			  add_action('admin_print_styles', array($this, 'AdminStyles') );
			  add_action( 'admin_head',  array($this, 'AdminHead') );
		  endif;
		  add_action( 'admin_init', array($this, 'RegisterSettings') );
		  add_action( 'init', array($this, 'Defaults') );
		  add_action('init', array($this, 'BlankChecks') );
		 
		  load_plugin_textdomain('cmsify', false, basename( dirname( __FILE__ ) ) . '/languages' );
		  
		  //ADMIN OPTIONS
		  add_action('wp_dashboard_setup', array($this, 'RemoveDashboardWidgets') );
		  add_action('widgets_init', array($this, 'RemoveWidgets'), 1);
		  add_filter('manage_posts_columns', array($this, 'RemovePostColumns') );
		  add_filter('manage_pages_columns', array($this, 'RemovePageColumns') );
		  add_action('admin_init',array($this, 'RemoveMetaBoxes') );
		  add_action('admin_init', array($this, 'DisableNotice') );
		  add_action('admin_head', array($this, 'AdminHeaderIcon') );
		  add_filter('admin_footer_text', array($this, 'AdminFooterCredits') );
		  
		  
		  //MEDIA
		  add_filter('wp_generate_attachment_metadata',array($this, 'MaxFullSize'));
		  add_action( 'wp_ajax_CMSifyReBuild', 'CMSifyReBuild' );
		  add_action( 'init', array($this, 'ImageSizes') );
		  
		  //EDITOR
		  add_filter( 'mce_css', array($this, 'CustomEditorStylesheet') );
		  add_filter('tiny_mce_before_init', array( $this, 'customformatTinyMCE') );
		  
		  
		} 
		add_action('login_head', array($this, 'LoginLogo') );
		
		$this->options = get_option('cmsify');
		$this->PluginPath = WP_PLUGIN_URL.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__));
	}
	function BlankChecks(){
		if (!$this->options["formats"]) $this->options["formats"] = array();
		if (!$this->options["dashboard_widgets"]['normal']) $this->options['dashboard_widgets']['normal'] = array();
		if (!$this->options["dashboard_widgets"]['side'])	$this->options['dashboard_widgets']['side'] = array();
		if (!$this->options["widgets"])		$this->options['widgets'] = array();
		if (!$this->options["post_columns"])	$this->options['post_columns'] = array();
		if (!$this->options["page_columns"])	$this->options['page_columns'] = array();	
		if (!$this->options['post_meta']) 		$this->options['post_meta']  = array();
		if (!$this->options['page_meta']) 		$this->options['page_meta']  = array();
	}
	function Defaults(){
		
		if( !isset($this->options["formats"]) ) $this->options["formats"] = array('p','h1','h2','h3','h4','h5','h6','pre','address');
		if( !isset($this->options["footercredits"]) ) $this->options["footercredits"]  = '<span id="footer-thankyou">Thank you for creating with <a href="http://wordpress.org/">WordPress</a>.</span> • <a href="http://codex.wordpress.org/">Documentation</a> • <a href="http://devbits.ca/wp-admin/freedoms.php">Freedoms</a> • <a href="http://wordpress.org/support/forum/4">Feedback</a> • <a href="http://devbits.ca/wp-admin/credits.php">Credits</a>';
			update_option('cmsify', $this->options);
		
	}
	function Add2Menu(){
		add_options_page(__('CMSify', 'cmsify'), __('CMSify', 'cmsify'), 'edit_pages', 'cmsify', array($this, 'SettingsPage'));	
	}
	function AdminScripts() {
		wp_enqueue_script('media-upload');
		wp_enqueue_script('thickbox');
		wp_register_script('CMSupload', $this->PluginPath .'/CMSupload.js', array('jquery','media-upload','thickbox'));
		wp_enqueue_script('CMSupload');
	}
		
	function AdminStyles() {
		wp_enqueue_style('thickbox');
	}
	
	function AdminHead(){
		
		if( $_GET['page'] == 'cmsify'):
		?>
        <script type='text/javascript' src='<?php echo $this->PluginPath;?>/jquery-ui-personalized-1.5.2.packed.js'></script>
        <script type="text/javascript">
        jQuery(document).ready(function($){
            $('#tabvanilla > ul').tabs({ fx: { height: 'toggle', opacity: 'toggle' } });
			function Cloneable(ID, inID){
                var sID = '#'+ID;
				var inID = '#'+inID;
				$(sID+' .btnAdd').click(function() {
					var num     = $(sID +' .clonedInput').length;
					var newNum  = new Number(num + 1);  
	
					var newElem = $(inID + num).clone().attr('id', inID + newNum);
					
	 
					newElem.children().each( function(){
						var prevnm = $(this).find('input').attr('name');
						var newnm = prevnm.replace(num,newNum);
						$(this).find('input').attr('name', newnm);
						$(this).find('input:not(.checkbox)').attr('value', '');
					});	
			   
					$(inID + num).after(newElem); 
					return false;
				});
	 
				$(sID + ' .btnDel').click(function() {
					var num = $(sID +' .clonedInput').length; 
					//alert(inID + num);
					if (num > 1)
						$(inID + num).remove(); 
					return false;
				});					
            }
			Cloneable('ImageSizes', 'input');
			Cloneable('FontSizes', 'finput');
			
        });
		</script>
        <style type="text/css">
	.widget {
    width: 90%;
    margin: 20px;
    padding: 10px;
    background: #f3f1eb;
    border: 1px solid #dedbd1;
    margin-bottom: 15px;
    }

    .widget a {
    color: #222;
    text-decoration: none;
    }

    .widget a:hover {
    color: #009;
    text-decoration: underline;
    }

    .tabnav li {
    display: inline;
    list-style: none;
    padding-right: 5px;
    }

    .tabnav li a {
    text-decoration: none;
    text-transform: uppercase;
    color: #222;
    font-weight: bold;
    padding: 4px 6px;
    outline: none;
    }

    .tabnav li a:hover, .tabnav li a:active, .tabnav li.ui-tabs-selected a {
    background: #dedbd1;
    color: #222;
    text-decoration: none;
    }

    .tabdiv {
    margin-top: 2px;
    background: #fff;
    border: 1px solid #dedbd1;
    padding: 5px;
    }
	.tabdiv h3{
		margin-left: 10px;	
	}
    .ui-tabs-hide {
    display: none;
    }
	.tabdiv tr{
		border-top:1px solid #DEDBD1;	
	}
	.tabdiv label{
		font-weight:bold;	
	}
	.tabdiv p{
		margin-left:10px;
	}
	.tabdiv a{
		text-decoration:underline;
		color:#21759B;	
	}
		</style>
        <?php	endif;
	}
	function RegisterSettings(){
		register_setting( 'cmsify-group', 'cmsify' );
	}
	
	function SettingsPage(){
		
		if( $_GET['reimg'] ): $this->ImageRebuildPanel();
		else:
		
		?>
        
       
        <div class="wrap">
        	<div id="icon-options-general" class="icon32"><br></div>
        	<h2><?php _e('CMSify Settings', 'cmsify');?></h2>
             
			 <?php // if( $_GET['settings-updated'] ) echo '<div id="setting-error-settings_updated" class="updated settings-error"><p><strong>'.__('Settings saved.', 'cmsify').'</strong></p></div>'; ?>

            <form action="options.php" method="post">
            	<?php 
				settings_fields( 'cmsify-group' );
				
				//echo '<pre>';print_r($this->options);echo '</pre>';
				?>
            	<input type="hidden" name="cp_action" value="save" />            
				
                <div id="tabvanilla" class="widget">
                

                  <ul class="tabnav">
                    <li><a href="#AdminOpts"><?php _e('Admin', 'cmsify');?></a></li>
                    <li><a href="#Media"><?php _e('Media', 'cmsify');?></a></li>
                    <li><a href="#Editor"><?php _e('Editor', 'cmsify');?></a></li>
                    <li><a href="#Recommendations"><?php _e('Recommendations', 'cmsify');?></a></li>
                 </ul>
                     <div id="AdminOpts" class="tabdiv">
                     <h3><?php _e('Administration Options', 'cmsify');?></h3>
                    <table class="form-table">
                    <tbody>
                       <tr valign="top">
                       <th scope="row"><label><?php _e('Upgrade Notifications', 'cmsify');?>:</label><br /><small><?php _e('Remove upgrade notifications for non-administrators', 'cmsify');?></small>
                       </th>
                            <td><label><input type="checkbox" value="1" name="cmsify[upgradenotice]" <?php if( $this->options['upgradenotice'] ) echo 'checked="checked"'; ?> /> <?php _e('Disable Upgrade Notice for Non-Admins', 'cmsify');?></label></td>
                        </tr>
                        
                       <tr valign="top">
                       <th scope="row"><label><?php _e('Dashboard Widgets', 'cmsify');?>:</label><br /><small><?php _e('Remove dashboard widgets from all users view', 'cmsify');?></small><br><?php echo $this->PreviewIMG('DashboardWidgets');?>
                       </th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;"><h4><?php _e('Main Column', 'cmsify');?></h4><label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][normal][]" value="dashboard_right_now" <?php if( in_array('dashboard_right_now', $this->options['dashboard_widgets']['normal']) ) echo 'checked="checked"';?> /> <?php _e('Right Now', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][normal][]" value="dashboard_recent_comments" <?php if( in_array('dashboard_recent_comments', $this->options['dashboard_widgets']['normal']) ) echo 'checked="checked"';?> /> <?php _e('Recent Comments', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][normal][]" value="dashboard_incoming_links" <?php if( in_array('dashboard_incoming_links', $this->options['dashboard_widgets']['normal']) ) echo 'checked="checked"';?> /> <?php _e('Incoming Links', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][normal][]" value="dashboard_plugins" <?php if( in_array('dashboard_plugins', $this->options['dashboard_widgets']['normal']) ) echo 'checked="checked"';?> /> <?php _e('Plugins', 'cmsify');?></label><br>
                                </div>
                                
                                <div style="width:30%; margin-right:2%; float:left;"><h4><?php _e('Side Column', 'cmsify');?></h4><label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][side][]" value="dashboard_quick_press" <?php if( in_array('dashboard_quick_press', $this->options['dashboard_widgets']['side']) ) echo 'checked="checked"';?> /> <?php _e('Quick Press', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][side][]" value="dashboard_recent_drafts" <?php if( in_array('dashboard_recent_drafts', $this->options['dashboard_widgets']['side']) ) echo 'checked="checked"';?> /> <?php _e('Recent Drafts', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][side][]" value="dashboard_primary" <?php if( in_array('dashboard_primary', $this->options['dashboard_widgets']['side']) ) echo 'checked="checked"';?> /> <?php _e('Primary Feed', 'cmsify');?></label><br>
                                 <label><input type="checkbox" class="checkbox" name="cmsify[dashboard_widgets][side][]" value="dashboard_secondary" <?php if( in_array('dashboard_secondary', $this->options['dashboard_widgets']['side']) ) echo 'checked="checked"';?> /> <?php _e('Secondary Feed', 'cmsify');?></label><br>
                                </div>
                                <div style="width:30%; margin-right:2%; float:left;"><h4><?php _e('Plugin Widgets', 'cmsify');?></h4>
                                <p><?php _e('Plugins that install dashboard widgets can be disabled below.  Get the value from the Dashboards Screen Options checkbox and enter them below - comma separated please.', 'cmsify');?></p>
                                <textarea name="cmsify[dashboard_widgets][plugins]" cols=20 rows=3 style="width:95%"><?php echo $this->options['dashboard_widgets']['plugins'];?></textarea>
                                </div>
                            </td>
                        </tr>
                        
                        <!-- WIDGETS -->
                        
                        <tr valign="top">
                       <th scope="row"><label><?php _e('Widgets', 'cmsify');?>:</label><br /><small><?php _e('Remove widgets from users view', 'cmsify');?></small><br><?php echo $this->PreviewIMG('Widgets');?></th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Archives" <?php if( in_array('WP_Widget_Archives', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Archives', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Calendar" <?php if( in_array('WP_Widget_Calendar', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Calendar', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Categories" <?php if( in_array('WP_Widget_Categories', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Categories', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Links" <?php if( in_array('WP_Widget_Links', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Links', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Meta" <?php if( in_array('WP_Widget_Meta', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Meta', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Pages" <?php if( in_array('WP_Widget_Pages', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Pages', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Recent_Comments" <?php if( in_array('WP_Widget_Recent_Comments', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Recent Comments', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Recent_Posts" <?php if( in_array('WP_Widget_Recent_Posts', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Recent Posts', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_RSS" <?php if( in_array('WP_Widget_RSS', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('RSS', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Search" <?php if( in_array('WP_Widget_Search', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Search', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Tag_Cloud" <?php if( in_array('WP_Widget_Tag_Cloud', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Tag Cloud', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[widgets][]" value="WP_Widget_Text" <?php if( in_array('WP_Widget_Text', $this->options['widgets']) ) echo 'checked="checked"';?> /> <?php _e('Text', 'cmsify');?></label><br>
                             
                             </div>
                             </td>
                         </tr>
                         
                        
                        
                        <!-- POST COLUMNS -->
                        
                        <tr valign="top">
                       <th scope="row"><label><?php _e('Post Columns', 'cmsify');?>:</label><br /><small><?php _e('Remove post columns from the View All Posts panel for all users', 'cmsify');?></small><br><?php echo $this->PreviewIMG('PostColumns');?></th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_columns][]" value="author" <?php if( in_array('author', $this->options['post_columns']) ) echo 'checked="checked"';?> /> <?php _e('Author', 'cmsify');?></label><br>
                               <label><input type="checkbox" class="checkbox" name="cmsify[post_columns][]" value="categories" <?php if( in_array('categories', $this->options['post_columns']) ) echo 'checked="checked"';?> /> <?php _e('Categories', 'cmsify');?></label><br>
                               </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_columns][]" value="comments" <?php if( in_array('comments', $this->options['post_columns']) ) echo 'checked="checked"';?> /> <?php _e('Comments', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_columns][]" value="tags" <?php if( in_array('tags', $this->options['post_columns']) ) echo 'checked="checked"';?> /> <?php _e('Tags', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                 <label><input type="checkbox" class="checkbox" name="cmsify[post_columns][]" value="date" <?php if( in_array('date', $this->options['post_columns']) ) echo 'checked="checked"';?> /> <?php _e('Date', 'cmsify');?></label><br>
                        </div>
                        <!--<div style="width:30%; margin-right:2%; float:left;">
                                <p>Plugins that install additional columns can be disabled to the right.  Get the value from the View All Posts Screen Options checkbox and enter them below - comma separated please.</p></div>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <textarea name="cmsify[post_columns_plugins]" cols=20 rows=3 style="width:95%"><?php echo $this->options['post_columns_plugins'];?></textarea>
                                </div>-->
                        
                        </td>
                        </tr>
                        
                         <!-- PAGE COLUMNS -->
                        
                        <tr valign="top">
                       <th scope="row"><label><?php _e('Page Columns', 'cmsify');?>:</label><br /><small><?php _e('Remove page columns from the View All Pages panel for all users', 'cmsify');?></small><br><?php echo $this->PreviewIMG('PageColumns');?></th></th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_columns][]" value="author" <?php if( in_array('author', $this->options['page_columns']) ) echo 'checked="checked"';?> /> <?php _e('Author', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_columns][]" value="comments" <?php if( in_array('comments', $this->options['page_columns']) ) echo 'checked="checked"';?> /> <?php _e('Comments', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_columns][]" value="date" <?php if( in_array('date', $this->options['page_columns']) ) echo 'checked="checked"';?> /> <?php _e('Date', 'cmsify');?></label><br>
                                
                        </div>
                        <!--<div style="width:30%; margin-right:2%; float:left;">
                                <p>Plugins that install additional columns can be disabled to the right.  Get the value from the View All Pages Screen Options checkbox and enter them below - comma separated please.</p></div>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <textarea name="cmsify[page_columns_plugins]" cols=20 rows=3 style="width:95%"><?php echo $this->options['page_columns_plugins'];?></textarea>
                                </div> -->
                        
                        </td>
                        </tr>
                        
                        <!-- POST META -->
                        <tr valign="top">
                       <th scope="row"><label><?php _e('Post Meta Boxes', 'cmsify');?>:</label><br /><small><?php _e('Remove post meta boxes from the Edit Posts panel for all users', 'cmsify');?></small><br><?php echo $this->PreviewIMG('PostMetaBoxes');?></th></th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="postexcerpt" <?php if( in_array('postexcerpt', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Excerpt', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="trackbacksdiv" <?php if( in_array('trackbacksdiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Send Trackbacks', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="postcustom" <?php if( in_array('postcustom', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Custom Fields', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="commentstatusdiv" <?php if( in_array('commentstatusdiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Discussions', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="commentsdiv" <?php if( in_array('commentsdiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Comments', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="slugdiv" <?php if( in_array('slugdiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Slug', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="authordiv" <?php if( in_array('authordiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Author', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="revisionsdiv" <?php if( in_array('revisionsdiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Revisions', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="categorydiv" <?php if( in_array('categorydiv', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Categories', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[post_meta][]" value="tagsdiv-post_tag" <?php if( in_array('tagsdiv-post_tag', $this->options['post_meta']) ) echo 'checked="checked"';?> /> <?php _e('Post Tags', 'cmsify');?></label><br>
                                
                              </div><div style="width:30%; margin-right:2%; float:left;">
                                <p><?php _e('Plugins that install additional meta boxes can be disabled below.  Get the value from the Edit Posts Screen Options checkbox and enter them below - comma separated please.', 'cmsify');?></p>
                                
                                <textarea name="cmsify[post_meta_plugins]" cols=20 rows=3 style="width:95%"><?php echo $this->options['post_meta_plugins'];?></textarea>
                                </div>
                              </td>
                        </tr>
                        
                        <!-- PAGE META -->
                        <tr valign="top">
                       <th scope="row"><label><?php _e('Page Meta Boxes', 'cmsify');?>:</label><br /><small><?php _e('Remove page meta boxes from the Edit Page panel for all users', 'cmsify');?></small><br><?php echo $this->PreviewIMG('PageMetaBoxes');?></th></th>
                            <td>
                                <div style="width:30%; margin-right:2%; float:left;">
                                
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="postcustom" <?php if( in_array('postcustom', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Custom Fields', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="commentstatusdiv" <?php if( in_array('commentstatusdiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Discussions', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="commentsdiv" <?php if( in_array('commentsdiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Comments', 'cmsify');?></label><br>
                                
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="slugdiv" <?php if( in_array('slugdiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Slug', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="authordiv" <?php if( in_array('authordiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Author', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="revisionsdiv" <?php if( in_array('revisionsdiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Revisions', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[page_meta][]" value="pageparentdiv" <?php if( in_array('pageparentdiv', $this->options['page_meta']) ) echo 'checked="checked"';?> /> <?php _e('Page Attributes', 'cmsify');?></label><br>
                               
                                
                              </div><div style="width:30%; margin-right:2%; float:left;">
                                <p><?php _e('Plugins that install additional meta boxes can be disabled below.  Get the value from the Edit Page Screen Options checkbox and enter them below - comma separated please.', 'cmsify');?></p>
                                
                                <textarea name="cmsify[page_meta_plugins]" cols=20 rows=3 style="width:95%"><?php echo $this->options['page_meta_plugins'];?></textarea>
                                </div>
                        
                              </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label><?php _e('Header Icon', 'cmsify');?>:</label></th>
                            <td><?php if($this->options['headericon']){ echo '<img src="'.$this->options['headericon'].'" alt="" width="16" height="16" />'; }?>	<input id="HeaderIcon" type="text" size="36" name="cmsify[headericon]" value="<?php echo $this->options['headericon'];?>" />	<input id="HeaderIconButton" type="button" value="Select/Upload New Icon" /> <br><small><?php _e('Upload or Select a 16x16 image to display instead of the WordPress icon in the Header area. (You can also type in a direct URL)', 'cmsify');?></small>
                            
                            </td>
                        </tr>
                        <tr valign="top">
                            <th scope="row"><label><?php _e('Footer Credits', 'cmsify');?>:</label></th>
                            <td><textarea  name="cmsify[footercredits]" id="footercredits" style="width:90%;height:100px;"><?php echo $this->options['footercredits'];?></textarea><br><small><?php _e('Enter any HTML text to display at the bottom of all admin panels.', 'cmsify');?></small>
                            
                            </td>
                        </tr>
                        
                        <tr valign="top">
                            <th scope="row"><label><?php _e('Login Logo', 'cmsify');?>:</label></th>
                            <td><?php if($this->options['loginlogo']){ echo '<br><img src="'.$this->options['loginlogo'].'" alt="" /><br />'; }?><input id="LoginLogo" type="text" size="36" name="cmsify[loginlogo]" value="<?php echo $this->options['loginlogo'];?>" />	<input id="LoginLogoButton" type="button" value="Select/Upload New Logo" /> <br><small><?php _e('Upload or Select an image to display instead of the WordPress logo in the wp-login.php page. (You can also type in a direct URL)', 'cmsify');?></small>
                            
                            </td>
                        </tr>
    
                    </tbody>
                    </table>
                    </div>
                    
                    
                    
                    <div id="Media" class="tabdiv">
                    <h3><?php _e('Media Options', 'cmsify');?></h3>
                    <table class="form-table">
                    <tbody>
                       <tr valign="top">
                            <th scope="row"><label><?php _e('Maximum Full Size', 'cmsify');?>:</label><br><small><?php _e('Set the maximum size your Media should save, this will replace your Full Size image.', 'cmsify');?></small></th>
                            
                            <td><label><?php _e('Height:', 'cmsify');?> <input type="text" name="cmsify[maxheight]" style="width:45px"  value="<?php echo $this->options["maxheight"];?>" /></label> <?php _e('px', 'cmsify');?>  &nbsp;
                             <label><?php _e('Width:', 'cmsify');?> <input type="text" name="cmsify[maxwidth]" style="width:45px"  value="<?php echo $this->options["maxwidth"];?>" /></label> <?php _e('px', 'cmsify');?> 
                            </td>
                            </tr>
                            <tr valign="top">
                            <th scope="row"><label><?php _e('Image Sizes', 'cmsify');?>:</label></th>
                            
                            <td>
                            <div id="ImageSizes">
                                
                            
                            <?php if($this->options['sizes']['label']): foreach($this->options['sizes']['label'] as $k=>$l):?>
                            <div id="input<?php echo $k;?>" style="margin-bottom:2px;" class="clonedInput">
                            <label><?php _e('Label:', 'cmsify');?> <input type="text" name="cmsify[sizes][label][<?php echo $k;?>]" style="width:150px"  value="<?php echo $this->options["sizes"]["label"][$k];?>" /> <small><?php _e('(no spaces/special characters)', 'cmsify');?></small></label>  &nbsp;&nbsp; 
                             <label><?php _e('Height:', 'cmsify');?> <input type="text" name="cmsify[sizes][height][<?php echo $k;?>]" style="width:45px"  value="<?php echo $this->options["sizes"]["height"][$k];?>" /></label> <?php _e('px', 'cmsify');?>  &nbsp;
                             <label><?php _e('Width:', 'cmsify');?> <input type="text" name="cmsify[sizes][width][<?php echo $k;?>]" style="width:45px"  value="<?php echo $this->options["sizes"]["width"][$k];?>" /></label> <?php _e('px', 'cmsify');?>  &nbsp;
                             <label><input type="checkbox" class="checkbox" name="cmsify[sizes][crop][<?php echo $k;?>]" style="width:45px"  value="1" <?php if( $this->options["sizes"]["crop"][$k] == 1) echo 'checked="checked"';?> /> <?php _e('Crop', 'cmsify');?></label>
                            </div>
                            <?php endforeach; else: ?>
                            <div id="input1" style="margin-bottom:2px;" class="clonedInput">
                            <label><?php _e('Label:', 'cmsify');?> <input type="text" name="cmsify[sizes][label][1]" style="width:150px"  /> <small><?php _e('(no spaces/special characters)', 'cmsify');?></small></label> &nbsp;&nbsp; 
                             <label><?php _e('Height:', 'cmsify');?> <input type="text" name="cmsify[sizes][height][1]" style="width:25px"  /> <?php _e('px', 'cmsify');?> </label> &nbsp; 
                             <label><?php _e('Width:', 'cmsify');?> <input type="text" name="cmsify[sizes][width][1]" style="width:25px"  /> <?php _e('px', 'cmsify');?> </label>  &nbsp; 
                             <label><input type="checkbox" class="checkbox" name="cmsify[sizes][crop][1]" style="width:25px"  value="1" /> <?php _e('Crop', 'cmsify');?></label>
                                </div>
                            <?php endif; ?>
                            <span style="margin-left:5px;"><a href="#Add" title="<?php _e('Add Another Row', 'cmsify');?>" class="btnAdd"><img src="<?php echo $this->PluginPath;?>add.png" style="height:16px;width:16px;vertical-align:middle" alt="<?php _e('Add Another Row', 'cmsify');?>" /></a><a href="#Remove" title="<?php _e('Remove Last Row', 'cmsify');?>" class="btnDel"><img src="<?php echo $this->PluginPath;?>remove.png" style="height:16px;width:16px;vertical-align:middle" alt="<?php _e('Remove Last Row', 'cmsify');?>" /></a></span>
                            </div>
                            <p><?php _e('New uploaded images will also be created with these sizes in addition to the usual, thumbnail, medium &amp; large.  You can use access these new images using the function <code>&lt;?php <a href="http://codex.wordpress.org/Function_Reference/wp_get_attachment_image_src" target="_blank">wp_get_attachment_image_src( $attachment_id, $size, $icon );</a> ?&gt; </code> where $size is the label you entered above.', 'cmsify');?></p>
                            <p><strong><a href="?page=cmsify&reimg=1" class="button"><?php _e('REBUILD ALL UPLOADED IMAGES', 'cmsify');?></a></strong></p>
                            </td>
                            </tr>
                       </tbody>
                     </table>
                    </div>
                    
                    
                    
                    
                    <div id="Editor" class="tabdiv">
                        <h3><?php _e('Editor Options', 'cmsify');?></h3>
                        <p><?php _e('CMSify recommends the <a href="http://wordpress.org/extend/plugins/tinymce-advanced/" target="_blank">TinyMCE Advanced</a> plugin for additional post/page editor functionality.', 'cmsify');?></p>
                        <table class="form-table">
                    <tbody>
                    
                    	<tr valign="top">
                            <th scope="row"><label><?php _e('Custom Editor Stylesheet', 'cmsify');?>:</label></th>
                            <td><?php echo get_stylesheet_directory_uri();?>/<input type="text" name="cmsify[customstyle]" id="customstyle" value="<?php echo $this->options['customstyle'];?>"  /><br><small><?php _e('Create and upload a custom stylesheet with all style rules prefixed with <code>.mceContentBody</code> to your themes directory and enter the filename.', 'cmsify');?></small>
                            
                            </td>
                        </tr>
                        
                       <tr valign="top">
                            <th scope="row"><label><?php _e('TinyMCE Block Format Selections', 'cmsify');?>:</label></th>
                            <td><?php  if( !is_array($this->options['formats'] ) ){ $this->options['formats'] = array(''); }
                            ?>
                                <div style="width:30%; margin-right:2%; float:left;"><label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="p" <?php if( in_array('p', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Paragraph', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h1" <?php if( in_array('h1', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 1', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h2" <?php if( in_array('h2', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 2', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h3" <?php if( in_array('h3', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 3', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h4" <?php if( in_array('h4', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 4', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h5" <?php if( in_array('h5', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 5', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="h6" <?php if( in_array('h6', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Heading 6', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="address" <?php if( in_array('address', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Address', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="pre" <?php if( in_array('pre', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Preformatted', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="div" <?php if( in_array('div', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Div', 'cmsify');?></label><br>
                                </div><div style="width:30%; margin-right:2%; float:left;">
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="blockquote" <?php if( in_array('blockquote', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Blockquote', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="dt" <?php if( in_array('dt', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Definition Term', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="dd" <?php if( in_array('dd', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Definition Description', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="code" <?php if( in_array('code', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Code', 'cmsify');?></label><br>
                                <label><input type="checkbox" class="checkbox" name="cmsify[formats][]" value="samp" <?php if( in_array('samp', $this->options['formats']) ) echo 'checked="checked"';?> /> <?php _e('Code Sample', 'cmsify');?></label>
                                </div>
                            </td>
                         </tr>
                          <tr valign="top">
                            <th scope="row"><label><?php _e('TinyMCE Custom Font Sizes', 'cmsify');?>:</label></th>
                            <td>
                            <div id="FontSizes">
                                
                            
                            <?php if($this->options['fontsizes']['label']): foreach($this->options['fontsizes']['label'] as $k=>$l):?>
                            <div id="finput<?php echo $k;?>" style="margin-bottom:2px;" class="clonedInput">
                            <label><?php _e('Label:', 'cmsify');?> <input type="text" name="cmsify[fontsizes][label][<?php echo $k;?>]" style="width:150px"  value="<?php echo $this->options["fontsizes"]["label"][$k];?>" /></label>  &nbsp;&nbsp; 
                             <label><?php _e('Value:', 'cmsify');?> <input type="text" name="cmsify[fontsizes][value][<?php echo $k;?>]" style="width:50px"  value="<?php echo $this->options["fontsizes"]["value"][$k];?>" /> <?php _e('(examples: 5px, 5em, small, .large)', 'cmsify');?></label>  &nbsp;
                             
                             
                            </div>
                            <?php endforeach; else: ?>
                            <div id="finput1" style="margin-bottom:2px;" class="clonedInput">
                            <label><?php _e('Label:', 'cmsify');?> <input type="text" name="cmsify[fontsizes][label][1]" style="width:150px"  /></label> &nbsp;&nbsp; 
                             <label><?php _e('Value:', 'cmsify');?> <input type="text" name="cmsify[fontsizes][value][1]" style="width:50px"  /> <?php _e('(examples: 5px, 5em, small, .large)', 'cmsify');?></label> &nbsp; 
                             
                                </div>
                            <?php endif; ?>
                            <span style="margin-left:5px;"><a href="#Add" title="<?php _e('Add Another Row', 'cmsify');?>" class="btnAdd"><img src="<?php echo $this->PluginPath;?>add.png" style="height:16px;width:16px;vertical-align:middle" alt="<?php _e('Add Another Row', 'cmsify');?>" /></a><a href="#Remove" title="<?php _e('Remove Last Row', 'cmsify');?>" class="btnDel"><img src="<?php echo $this->PluginPath;?>remove.png" style="height:16px;width:16px;vertical-align:middle" alt="<?php _e('Remove Last Row', 'cmsify');?>" /></a></span>
                            </div>
                            </td>
                          </tr>
                       </tbody>
                     </table>
                    </div>
                    <div id="Recommendations" class="tabdiv">
                    	<h3><?php _e('Recommendations', 'cmsify');?></h3>
                        <p><?php _e('The following is a list of Plugins that CMSify recommends for further enhancement of your WordPress CMS environment:', 'cmsify');?></p>
                        <ol>
                        	<li><strong><a href="http://wordpress.org/extend/plugins/tinymce-advanced/" target="_blank"><?php _e('TinyMCE Advanced', 'cmsify');?></a></strong> - <?php _e('Enables the advanced features of TinyMCE, the WordPress WYSIWYG editor.', 'cmsify');?></li>
                            <li><strong><a href="http://wordpress.org/extend/plugins/wordpress-seo/" target="_blank"><?php _e('WordPress SEO by Yoast', 'cmsify');?></a></strong> - <?php _e('Yoast\'s all in one SEO solution for your WordPress blog: SEO titles, meta descriptions, XML sitemaps, breadcrumbs &amp; much more.', 'cmsify');?></li>
                            <li><strong><a href="http://wordpress.org/extend/plugins/pods/" target="_blank"><?php _e('Pods CMS', 'cmsify');?></a></strong> - <?php _e('Pods is a CMS framework for creating, managing, and deploying customized content types.', 'cmsify');?></li>
                            <li><strong><a href="http://wordpress.org/extend/plugins/more-fields/" target="_blank"><?php _e('More Fields', 'cmsify');?></a></strong> - <?php _e('Adds any number of extra fields in any number of additional boxes on the Write/Edit page in the Admin.', 'cmsify');?></li>
                            <li><strong><a href="http://wordpress.org/extend/plugins/simple-page-ordering/" target="_blank"><?php _e('Simple Page Ordering', 'cmsify');?></a></strong> - <?php _e('Order your pages and other hierarchical post types with simple drag and drop. Also adds a drop down to change items per page.', 'cmsify');?></li>
                            <li><strong><a href="http://www.gravityforms.com/" target="_blank"><?php _e('Gravity Forms', 'cmsify');?></a></strong> - <?php _e('Premium Form Creator for WordPress', 'cmsify');?></li>
                            <li><strong><a href="https://shopplugin.net/" target="_blank"><?php _e('Shopp', 'cmsify');?></a></strong> - <?php _e('Premium e-commerce plugin that adds a feature-rich online store to WordPress', 'cmsify');?></li>
                        </ol>
                    </div>
                    
                </div>
                <p class="submit">
                <input name="Submit" class="button-primary" value="<?php _e('Save Changes', 'cmsify');?>" type="submit">
                </p>

            </form>
        </div>
        <?php
		endif;
	}
	
	/* IMAGE SIZE FUNCTIONS */
	function ImageRebuildPanel(){
		
		?>
        <div id="message" class="updated fade" style="display:none;"></div>
		<script type="text/javascript">
		// <![CDATA[

		function ShowMessage(m) {
			jQuery("#message").html(m);
			jQuery("#message").show();
		}
		function setMessage(m){
			jQuery("#message").append(m);	
		}

		function Rebuild() {
			jQuery("#RebuildImages").attr("disabled", true);
			ShowMessage("<p>Loading Images&hellip;</p>");

			inputs = jQuery( 'input:checked' );
			var sizes = '';
			if( inputs.length != jQuery( 'input[type=checkbox]' ).length ){
				inputs.each( function(){
					sizes += '&sizes[]='+jQuery(this).val();
					
				} );
			}

			jQuery.ajax({
				url: "<?php bloginfo('wpurl'); ?>/wp-admin/admin-ajax.php", 
				type: "POST",
				data: "action=CMSifyReBuild&do=getlist",
				success: function(result) {
					var list = eval(result);
					var curr = 0;

					function regenItem() {
						if (curr >= list.length) {
							jQuery("#RebuildImages").removeAttr("disabled");
							setMessage("<?php _e('All Images Rebuilt.', 'cmsify');?>");
							return;
						}
						setMessage("<?php _e('Rebuilding', 'cmsify');?> " + (curr+1) + " of " + list.length + " (" + list[curr].title + ")...");

						jQuery.ajax({
							url: "<?php bloginfo('wpurl'); ?>/wp-admin/admin-ajax.php",
							type: "POST",
							data: "action=CMSifyReBuild&do=regen&id=" + list[curr].id + sizes,
							success: function(result) {
								jQuery("#LastDone").show();
								jQuery("#Done").attr("src",result);

								curr = curr + 1;
								regenItem();
							}
						});
					}

					regenItem();
				},
				error: function(request, status, error) {
					setMessage("<?php _e('Rebuild Error', 'cmsify');?> " + request.status);
				}
			});
		}

		// ]]>
		</script>
        <div class="wrap">
        	<div id="icon-options-general" class="icon32"><br></div>
        	<h2><a href="?page=cmsify"><?php _e('CMSify', 'cmsify');?></a> &raquo; <?php _e('Rebuild Image Sizes', 'cmsify');?></h2>
            
            
            <form method="post" action="">
            <p><?php _e('Rebuild your current uploaded images to new image sizes.', 'cmsify');?></p>
            <table class="form-table">
                <tbody>
                   <tr valign="top">
                        <th scope="row"><label><?php _e('Select Image Sizes to Rebuild', 'cmsify');?>:</label></th>
                        <td>
            <?php
			global $_wp_additional_image_sizes;

			foreach ( get_intermediate_image_sizes() as $s ):

				if ( isset( $_wp_additional_image_sizes[$s]['width'] ) ) // For theme-added sizes
					$width = intval( $_wp_additional_image_sizes[$s]['width'] );
				else                                                     // For default sizes set in options
					$width = get_option( "{$s}_size_w" );

				if ( isset( $_wp_additional_image_sizes[$s]['height'] ) ) // For theme-added sizes
					$height = intval( $_wp_additional_image_sizes[$s]['height'] );
				else                                                      // For default sizes set in options
					$height = get_option( "{$s}_size_h" );

				if ( isset( $_wp_additional_image_sizes[$s]['crop'] ) )   // For theme-added sizes
					$crop = intval( $_wp_additional_image_sizes[$s]['crop'] );
				else                                                      // For default sizes set in options
					$crop = get_option( "{$s}_crop" );
			?>
            <label><input type="checkbox" name="sizes[]"  value="<?php echo $s ?>" />
				
					<strong style="text-transform:capitalize"><?php echo $s ?></strong> <?php echo $width ?>x<?php echo $height ?><?php echo ($crop == 1?' <em>'.__('cropped', 'cmsify').'</em>':'') ?>
				</label>
				<br/>
			<?php endforeach;?>
            </td>
            <td><p id="LastDone" style="display:none;"><strong><?php _e('Last Rebuilt', 'cmsify');?></strong> <small><?php _e('(showing thumbnail size only):', 'cmsify');?></small><br><img id="Done" /></p></td>
            </tr>
            </tbody>
            </table>
            <p class="submit">
                <input name="RebuildImages" id="RebuildImages" class="button-primary" value="<?php _e('Rebuild Selected Image Sizes', 'cmsify');?>" type="button" onClick="javascript:Rebuild();">
                </p>
            </form>
            
        </div>
        <?php	
	}
	function ImageRebuild(){
		global $wpdb;
		$action = $_POST["do"];
		$thumbnails = isset( $_POST['sizes'] )? $_POST['sizes'] : NULL;
	
		if ($action == "getlist") {
	
				$attachments =& get_children( array(
					'post_type' => 'attachment',
					'post_mime_type' => 'image',
					'numberposts' => -1,
					'post_status' => null,
					'post_parent' => null, // any parent
					'output' => 'object',
				) );
			
	
			foreach ( $attachments as $attachment ) {
				$res[] = array('id' => $attachment->ID, 'title' => $attachment->post_title);
			}
			die( json_encode($res) );
		} else if ($action == "regen") {
			$id = $_POST["id"];
	
			$fullsizepath = get_attached_file( $id );
	
			if ( FALSE !== $fullsizepath && @file_exists($fullsizepath) ) {
				set_time_limit( 30 );
				wp_update_attachment_metadata( $id, wp_generate_attachment_metadata( $id, $fullsizepath ) );
			}
	
			die( wp_get_attachment_thumb_url( $id ));
		}
	}
	
	function ImageSizes(){
		$s = $this->options['sizes'];
		if($s):
		foreach($s['label'] as $k=>$l):
			if( function_exists( 'add_image_size' ) ) {	 
				add_image_size( $s['label'][$k], $s['height'][$k], $s['width'][$k], $s['crop'][$k] );
			}	
		endforeach;
		endif;
		$maxh = $this->options['maxheight'];
		$maxw = $this->options['maxwidth'];
		if( $maxh && $maxw ) add_image_size( 'MaxFull', $maxh, $maxw, false );
	}
	/* END IMAGE SIZE FUNCTIONS */
	
	
	
	/*TinyMCE Functions*/
	function customformatTinyMCE($init) {
		$formats = implode(',',$this->options['formats']);
		// Add block format elements you want to show in dropdown
		$init['theme_advanced_blockformats'] = $formats;
		
		foreach( $this->options['fontsizes']['label'] as $k =>$l ):
			$sizes[] = $l.'='.$this->options['fontsizes']['value'][$k];
		endforeach;
		$init['theme_advanced_font_sizes'] = implode(';', $sizes);
		return $init;
	}
	//Add custom styles to editor
	function CustomEditorStylesheet($url){ 
		if( $this->options['customstyle'] ):
			$url = get_stylesheet_directory_uri() . '/' . $this->options['customstyle'];
			return $url;
		endif;
	}
	
	//Remove Dashboard Widgets
	function RemoveDashboardWidgets(){
		foreach( $this->options['dashboard_widgets']['normal'] as $k => $widget ):
			remove_meta_box( $widget, 'dashboard', 'normal' );
		endforeach;
		foreach( $this->options['dashboard_widgets']['side'] as $k => $widget ):
			remove_meta_box( $widget, 'dashboard', 'side' );
		endforeach;
		$plugins = explode(",", $this->options['dashboard_widgets']['plugins']);
		foreach( $plugins as $k => $widget ):
			remove_meta_box( $widget, 'dashboard', 'normal' );
			remove_meta_box( $widget, 'dashboard', 'side' );
		endforeach;
	}
	function RemoveWidgets(){
	  	$widgets = $this->options['widgets'];
		if( $widgets) :
		foreach( $widgets as $k => $widget ):
		  unregister_widget($widget);
	  	endforeach;
		endif;
	}
	
	
	
	//Remove Post Columns
	function RemovePostColumns($defaults) {
	  //print_r($defaults);
	  foreach( $this->options['post_columns'] as $k =>$colname ):
		  unset($defaults[$colname]);
	  endforeach; 
	  $plugged = explode(",", $this->options['post_columns_plugins']);
	  foreach( $plugged as $k =>$colname ):
		  unset($defaults[$colname]);
	  endforeach;  
	  return $defaults;
	}
	
	//Remove Page Columns
	function RemovePageColumns($defaults) {
	  foreach( $this->options['page_columns'] as $k =>$colname ):
		  unset($defaults[$colname]);
	  endforeach;  
	  $plugged = explode(",", $this->options['page_columns_plugins']);
	  foreach( $plugged as $k =>$colname ):
		  unset($defaults[$colname]);
	  endforeach;  
	  return $defaults;
	}
	
	//Remove Meta Boxes
	function RemoveMetaBoxes(){
		foreach( $this->options['post_meta'] as $k => $meta ):
			remove_meta_box($meta,'post','normal');
		endforeach;
		$plugged = explode(",", $this->options['post_meta_plugins']);
	  foreach( $plugged as $k =>$meta ):
		  remove_meta_box($meta,'post','normal');
	  endforeach; 
	  
	  foreach( $this->options['page_meta'] as $k => $meta ):
			remove_meta_box($meta,'page','normal');
		endforeach;
		$plugged = explode(",", $this->options['page_meta_plugins']);
	  foreach( $plugged as $k =>$meta ):
		  remove_meta_box($meta,'page','normal');
	  endforeach; 
	}
	
	function MaxFullSize($image_data) {	
		if (!isset($image_data['sizes']['MaxFull'])) return $image_data;
		//define the new Full location/file
		$upload_dir = wp_upload_dir();
		$uploaded_image_location = $upload_dir['basedir'] . '/' .$image_data['file'];
		$large_image_location = $upload_dir['path'] . '/'.$image_data['sizes']['MaxFull']['file'];
		// delete the original uploaded image
		unlink($uploaded_image_location);
		// rename the MaxFull image
		rename($large_image_location,$uploaded_image_location);
		// update image metadata
		$image_data['width'] = $image_data['sizes']['MaxFull']['width'];
		$image_data['height'] = $image_data['sizes']['MaxFull']['height'];
		//remove MaxFull size as it is now the full size
		unset($image_data['sizes']['MaxFull']);
		return $image_data;
	}
	
	function DisableNotice(){
		if( !current_user_can('administrator') && $this->options['upgradenotice'] )
			add_filter( 'pre_site_transient_update_core', create_function( '$a', "return null;" ) );	
	}
	
	function PreviewIMG($imgnm){
		return '<a href="'.$this->PluginPath.'imgs/'.$imgnm.'.png" class="thickbox"><img src="'.$this->PluginPath.'imgs/'.$imgnm.'.png" width="95%" alt="" /></a>';	
	}
	function AdminHeaderIcon() {
	  if( $this->options['headericon'] ):
	  	echo '<style type="text/css">
		#header-logo { background-image: url('.$this->options['headericon'].') !important; }
		</style>';
	  endif;
}
	function AdminFooterCredits () {
	  echo $this->options['footercredits'];
	}
	function LoginLogo() {
	  	if( $this->options['loginlogo'] ):
		  echo '<style type="text/css">
			h1 a { background-image:url('.$this->options['loginlogo'].') !important; }
			</style>';
		endif;
	}


}
$cmsify = new CMSIFY();

function CMSifyReBuild(){
	global $cmsify;
	$cmsify->ImageRebuild();	
}
?>